%if 0%{?scl:1}
%scl_package mod_auth_mellon
%global sub_prefix sclo-%{scl_prefix}
%endif

%if 0%{?scl:1}
%{!?_httpd24_apxs:       %{expand: %%global _httpd24_apxs       %%{_sbindir}/apxs}}
%{!?_httpd24_mmn:        %{expand: %%global _httpd24_mmn        %%(cat %{_includedir}/httpd/.mmn 2>/dev/null || echo missing-httpd-devel)}}
%{!?_httpd24_confdir:    %{expand: %%global _httpd24_confdir    %%{_sysconfdir}/httpd/conf.d}}
# /etc/httpd/conf.d with httpd < 2.4 and defined as /etc/httpd/conf.modules.d with httpd >= 2.4
%{!?_httpd24_modconfdir: %{expand: %%global _httpd24_modconfdir %%{_sysconfdir}/httpd/conf.d}}
%{!?_httpd24_moddir:    %{expand: %%global _httpd24_moddir    %%{_libdir}/httpd/modules}}
%else
%{!?_httpd_apxs:       %{expand: %%global _httpd_apxs       %%{_sbindir}/apxs}}
%{!?_httpd_mmn:        %{expand: %%global _httpd_mmn        %%(cat %{_includedir}/httpd/.mmn 2>/dev/null || echo missing-httpd-devel)}}
%{!?_httpd_confdir:    %{expand: %%global _httpd_confdir    %%{_sysconfdir}/httpd/conf.d}}
# /etc/httpd/conf.d with httpd < 2.4 and defined as /etc/httpd/conf.modules.d with httpd >= 2.4
%{!?_httpd_modconfdir: %{expand: %%global _httpd_modconfdir %%{_sysconfdir}/httpd/conf.d}}
%{!?_httpd_moddir:    %{expand: %%global _httpd_moddir    %%{_libdir}/httpd/modules}}
%endif

%if 0%{?rhel} < 7
%define my_rundir /var/run
%else
%define my_rundir %{_rundir}
%endif

Summary: A SAML 2.0 authentication module for the Apache Httpd Server
Name: %{?scl:%sub_prefix}mod_auth_mellon
Version: 0.12.0
Release: 1%{?dist}
Group: System Environment/Daemons
Source0: https://github.com/UNINETT/mod_auth_mellon/releases/download/v%{version}/mod_auth_mellon-%{version}.tar.gz
Source1: auth_mellon.conf
Source2: 10-auth_mellon.conf
Source3: mod_auth_mellon.conf
Source4: mellon_create_metadata.sh
License: GPLv2+
BuildRequires: curl-devel
BuildRequires: glib2-devel
BuildRequires: %{?scl:%scl_prefix}httpd-devel
%if 0%{?rhel} < 7
BuildRequires: lasso-devel >= 2.4.0
Requires: lasso >= 2.4.0
%else
BuildRequires: lasso-devel >= 2.5.0
Requires: lasso >= 2.5.0
%endif
BuildRequires: openssl-devel
BuildRequires: xmlsec1-devel
%if 0%{?scl:1}
Requires: %{?scl:%scl_prefix}httpd-mmn = %{_httpd24_mmn}
%else
Requires: httpd-mmn = %{_httpd_mmn}
%endif

Url: https://github.com/UNINETT/mod_auth_mellon
Requires(pre): %{?scl:%scl_prefix}httpd
%{?scl:Requires:%scl_runtime}

Provides: %{?scl_prefix}mod_auth_mellon = %{version}-%{release}
Provides: %{?scl_prefix}mod_auth_mellon%{_isa} = %{version}-%{release}

# Suppres auto-provides for module DSO
%{?filter_provides_in: %filter_provides_in %{_libdir}/httpd/modules/.*\.so$}
%{?filter_setup}


%description
The mod_auth_mellon module is an authentication service that implements the
SAML 2.0 federation protocol. It grants access based on the attributes
received in assertions generated by a IdP server.

%prep
%setup -q -n mod_auth_mellon-%{version}

%build
%if 0%{?scl:1}
%configure --with-apxs2=%{_httpd24_apxs}
%else
%configure --with-apxs2=%{_httpd_apxs}
%endif

make %{?_smp_mflags}

%install
# install module


%if 0%{?scl:1}
mkdir -p %{buildroot}%{_httpd24_moddir}
install -m 755 .libs/mod_auth_mellon.so %{buildroot}%{_httpd24_moddir}
%else
mkdir -p %{buildroot}%{_httpd_moddir}
install -m 755 .libs/mod_auth_mellon.so %{buildroot}%{_httpd_moddir}
%endif

# install module configuration
%if 0%{?scl:1}
mkdir -p %{buildroot}%{_httpd24_confdir}
install -m 644 %{SOURCE1} %{buildroot}%{_httpd24_confdir}
mkdir -p %{buildroot}%{_httpd24_modconfdir}
install -m 644 %{SOURCE2} %{buildroot}%{_httpd24_modconfdir}
%else
mkdir -p %{buildroot}%{_httpd_confdir}
install -m 644 %{SOURCE1} %{buildroot}%{_httpd_confdir}
mkdir -p %{buildroot}%{_httpd_modconfdir}
install -m 644 %{SOURCE2} %{buildroot}%{_httpd_modconfdir}
mkdir -p %{buildroot}%{_tmpfilesdir}
%endif

%if 0%{?rhel} > 6
%if 0%{!?scl:1}
mkdir -p %{buildroot}%{?scl:%_scl_root}/%{_tmpfilesdir}
install -m 644 %{SOURCE3} %{buildroot}%{?scl:%_scl_root}/%{_tmpfilesdir}
%endif
%endif

mkdir -p %{buildroot}%{?scl:%_scl_root}/%{my_rundir}/mod_auth_mellon


%if 0%{?scl:1}
sed -i 's#/run/#%{_scl_root}%{my_rundir}/#' %{buildroot}%{_httpd24_confdir}/auth_mellon.conf
%endif


# install script to generate metadata
mkdir -p %{buildroot}/%{_libexecdir}/mod_auth_mellon
install -m 755 %{SOURCE4} %{buildroot}/%{_libexecdir}/mod_auth_mellon

%files
%defattr(-,root,root)
%doc README COPYING NEWS
%if 0%{?scl:1}
%config(noreplace) %{_httpd24_modconfdir}/10-auth_mellon.conf
%config(noreplace) %{_httpd24_confdir}/auth_mellon.conf
%{_httpd24_moddir}/mod_auth_mellon.so
%{_libexecdir}/mod_auth_mellon
%dir %{_scl_root}%{my_rundir}/mod_auth_mellon/
%else
%config(noreplace) %{_httpd_modconfdir}/10-auth_mellon.conf
%config(noreplace) %{_httpd_confdir}/auth_mellon.conf
%if 0%{?rhel} > 6
%{_tmpfilesdir}/mod_auth_mellon.conf
%endif
%{_httpd_moddir}/mod_auth_mellon.so
%{_libexecdir}/mod_auth_mellon
%dir %{my_rundir}/mod_auth_mellon/
%endif

%changelog
* Wed Mar 09 2016 Jaroslaw Polok <jaroslaw.polok@cern.ch>  - 0.12.0-1
- update to 0.12.0.
- CVE-2016-2145 fix.
- CVE-2016-2146 fix.

* Tue Feb 23 2016 Jaroslaw Polok <jaroslaw.polok@cern.ch>  - 0.11.0-4
- initial candidate build on cbs.centos.org

* Wed Jan 27 2016 Jaroslaw Polok <jaroslaw.polok@cern.ch>  - 0.11.0-3
- spec file fixes for building on el6 and el7.

* Fri Jan 22 2016 Jaroslaw Polok <jaroslaw.polok@cern.ch>  - 0.11.0-2
- repackage as Software Collection

* Fri Sep 18 2015 John Dennis <jdennis@redhat.com> - 0.11.0-1
- Upgrade to upstream 0.11.0 release.
- Includes ECP support, see NEWS for all changes.
- Update mellon_create_metadata.sh to match internally generated metadata,
  includes AssertionConsumerService for postResponse, artifactResponse &
  paosResponse.
- Add lasso 2.5.0 version dependency
- Resolves: #1205345

* Mon Aug 24 2015 John Dennis <jdennis@redhat.com> - 0.10.0-3
- Rebase to upstream 0.10.0 release
- Apply upstream commits post 0.10.0 release
- Apply revised ECP pending patches,
  fix patch to pickup change in configure script that causes
  HAVE_ECP to be defined
- Resolves: #1205345

* Wed Aug 19 2015 John Dennis <jdennis@redhat.com> - 0.10.0-2
- Rebase to upstream 0.10.0 release
- Apply upstream commits post 0.10.0 release
- Apply revised ECP pending patches
- Resolves: #1205345

* Mon Jun 22 2015 John Dennis <jdennis@redhat.com> - 0.10.0-1
- Rebase to upstream 0.10.0 release
- Apply upstream commits post 0.10.0 release
- Apply ECP pending patches
- Resolves: #1205345

* Mon Dec  8 2014 Simo Sorce <simo@redhat.com> 0.9.1-4
- Large scale intreop patches
- Resolves: #1167844

* Wed Sep 10 2014 Simo Sorce <simo@redhat.com> 0.9.1-3
- Fix upstream sources URL
- Related: #1120353

* Fri Sep  5 2014 Simo Sorce <simo@redhat.com> 0.9.1-2
- Import package in RHEL7
- Resolves: #1120353

* Tue Sep  2 2014 Simo Sorce <simo@redhat.com> 0.9.1-1
- New upstream release

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Jun 24 2014 Simo Sorce <simo@redhat.com> 0.8.0-1
- New upstream realease version 0.8.0
- Upstream moved to github
- Drops patches as they have been all included upstream

* Fri Jun 20 2014 Simo Sorce <simo@redhat.com> 0.7.0-3
- Backport of useful patches from upstream
  - Better handling of IDP reported errors
  - Better handling of session data storage size

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Dec 10 2013 Simo Sorce <simo@redhat.com> 0.7.0-1
- Fix ownership of /run files

* Wed Nov 27 2013 Simo Sorce <simo@redhat.com> 0.7.0-0
- Initial Fedora release based on version 0.7.0
- Based on an old spec file by Jean-Marc Liger <jmliger@siris.sorbonne.fr>
